import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.SortedSet;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class lexical_scratch implements Comparator<Integer> {
	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	boolean hasNextToken() {
		try {
			while (!st.hasMoreTokens()) {
				String line = input.readLine();
				if (line == null) return false;
				st = new StringTokenizer(line);
			}
		} catch (IOException ex) { throw new RuntimeException(ex); }
		return true;
	}
	String nextToken() {
		return (!hasNextToken()) ? null : st.nextToken();
	}
	int nextInt() {
		return Integer.parseInt(nextToken());
	}
	public static void main(String[] args) {
		new lexical_scratch().run();
	}
	
	int n, k;
	int[][] rank;
	int curidx, curlen;
	
	class KComparator implements Comparator<Integer> {
		@Override
		public int compare(Integer o1, Integer o2) {
			int i1 = o1.intValue(), i2 = o2.intValue();
			int ci = curidx, cl = curlen;
			while (cl > 0) {
				if ((cl & k) > 0) {
					int dif = rank[ci][i1%n] - rank[ci][i2%n];
					if (dif != 0)
						return dif;
					i1 += cl; i2 += cl;
				}
				--ci;
				cl >>= 1;
			}
			return (i1%n) - (i2%n);
		}
	}
	KComparator KCOMP = new KComparator();
	
	@Override
	public int compare(Integer o1, Integer o2) {
		int i1 = o1.intValue(), i2 = o2.intValue();
		int dif = rank[curidx][i1] - rank[curidx][i2];
		if (dif != 0) return dif;
		return rank[curidx][(i1+curlen) % n] - rank[curidx][(i2+curlen) % n];
	}
	
	void run() {
		n = nextInt(); k = nextInt();
		char[] cyc = nextToken().toCharArray();
		rank = new int[20][n];
		for (int i = 0; i < n; ++i) rank[0][i] = cyc[i];
		curidx = 0; curlen = 1;
		List<Integer> idx = new ArrayList<>(n);
		for (int i = 0; i < n; ++i) idx.add(Integer.valueOf(i));
		while (curlen < k) {
			idx.sort(this);
			Integer prev = null;
			int r = 0;
			for (Integer i : idx) {
				if (prev == null || this.compare(prev, i) != 0) ++r;
				prev = i;
				rank[curidx+1][i.intValue()] = r;
			}
			++curidx;
			curlen <<= 1;
		}
		SortedSet<Integer> active = new TreeSet<>(KCOMP);
		for (int i = 0; i < k; ++i) active.add(Integer.valueOf(i));
		Integer max = active.first();
		for (int i = 0; i < n; ++i) {
			active.remove(Integer.valueOf(i));
			active.add(Integer.valueOf(k + i));
			if (KCOMP.compare(active.first(), max) > 0) {
				max = active.first();
			}
		}
		for (int i = 0; i < k; ++i) {
			System.out.print(cyc[(max.intValue() + i) % n]);
		}
		System.out.println();
	}
}
