#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ii = pair<ll,ll>;
using vi = vector<int>;
using vii = vector<ii>;
using vvi = vector<vi>;
#define ALL(x) (x).begin(),(x).end()
#define ff first
#define ss second
#define D(a) cerr << ">> " << #a << " = >" << a << "<" << endl
#define PB push_back
#define F(i,a,b) for ( int i = int(a); i < int(b); ++i )
#define FD(i,a,b) for ( int i = int(a); i >= int(b); --i )
#define R1(a) scanf("%d",&a)
#define R2(a,b) scanf("%d%d",&a,&b)
#define R3(a,b,c) scanf("%d%d%d",&a,&b,&c)
#define DR1(a) int a; scanf("%d",&a)
#define DR2(a,b) int a,b; scanf("%d%d",&a,&b)
#define DR3(a,b,c) int a,b,c; scanf("%d%d%d",&a,&b,&c)

const int INF = 1e9 + 7;
constexpr const double PI = acos(-1);
const double EPS = 1e-9;

// reading input
bool R() { return true; }
template <typename T, typename... Args>
bool R(T & x, Args & ... args) {
    cin >> x;
    return cin && R(args...);
}
template <typename T1, typename T2>
istream & operator>>(istream & is, pair<T1,T2> & p) {
    is >> p.first >> p.second;
    return is;
}
template <typename T>
istream & operator>>(istream & is, vector<T> & v) {
    for (T & x : v)
        is >> x;
    return is;
}

// printing output
template <typename Container>
std::ostream & print(std::ostream & os, const Container & container, const string & sep = " ", const string & ending = "") {
    auto it = begin(container);
    if (it != end(container)) {
        os << *it;
        while (++it != end(container))
            os << sep << *it;
    }
      
    for (auto it = begin(container); it != end(container); ++it) {
        if (it != begin(container))
            os << sep;
        os << *it;
    }
    return os << ending;
}
template <typename T1, typename T2>
ostream & operator<<(ostream & os, const pair<T1,T2> & p) {
    return os << "{" << p.ff << " " << p.ss << "}";
}
template <typename Type>
std::ostream & operator<<(std::ostream & os, const vector<Type> & container) {
    return print(os, container);
}
template <typename Type>
std::ostream & operator<<(std::ostream & os, const set<Type> & container) {
    return print(os, container);
}


// static const int N = 1 << 21;
// char S[N] = { 0 };
// int n, k, gap;
// int sa[N], pos[N], tmp[N], lcp[N];

// bool sufCmp( int i, int j ) {
//     if ( pos[i] != pos[j] )
//         return pos[i] < pos[j];
//     i += gap;
//     j += gap;
//     return (i < n && j < n) ? pos[i] < pos[j] : i > j;
// }

// void buildSA( ) {
//     int N = 2 * n;
//     F(i,0,N)
//         sa[i] = i, pos[i] = S[i];
//     for (gap = 1; ; gap *= 2) {
//         sort(sa, sa + N, sufCmp);
//         F(i,0,N-1)
//             tmp[i + 1] = tmp[i] + sufCmp( sa[i], sa[i + 1] );
//         F(i,0,N)
//             pos[sa[i]] = tmp[i];
//         if (tmp[N-1] == N-1)
//             break;
//     }
// }

#define MAX_N 1000010 // second approach: O(n log n)
char T[MAX_N]; // the input string, up to 100K characters
int n; // the length of input string
int RA[MAX_N], tempRA[MAX_N]; // rank array and temporary rank array
int SA[MAX_N], tempSA[MAX_N]; // suffix array and temporary suffix array
int c[MAX_N]; // for counting/radix sort
int k;

void countingSort(int k) { // O(n)
    int i, sum, maxi = max(300, n); // up to 255 ASCII chars or length of n
    memset(c, 0, sizeof c); // clear frequency table
    for (i = 0; i < n; i++) // count the frequency of each integer rank
    c[i + k < n ? RA[i + k] : 0]++;
    for (i = sum = 0; i < maxi; i++) {
    int t = c[i]; c[i] = sum; sum += t; }
    for (i = 0; i < n; i++) // shuffle the suffix array if necessary
    tempSA[c[SA[i]+k < n ? RA[SA[i]+k] : 0]++] = SA[i];
    for (i = 0; i < n; i++) // update the suffix array SA
    SA[i] = tempSA[i];
}

void constructSA() { // this version can go up to 100000 characters
    int i, k, r;
    for (i = 0; i < n; i++) RA[i] = T[i]; // initial rankings
    for (i = 0; i < n; i++) SA[i] = i; // initial SA: {0, 1, 2, ..., n-1}
    for (k = 1; k < n; k <<= 1) { // repeat sorting process log n times
    countingSort(k); // actually radix sort: sort based on the second item
    countingSort(0); // then (stable) sort based on the first item
    tempRA[SA[0]] = r = 0; // re-ranking; start from rank r = 0
    for (i = 1; i < n; i++) // compare adjacent suffixes
    tempRA[SA[i]] = // if same pair => same rank r; otherwise, increase r
    (RA[SA[i]] == RA[SA[i-1]] && RA[SA[i]+k] == RA[SA[i-1]+k]) ? r : ++r;
    for (i = 0; i < n; i++) // update the rank array RA
    RA[i] = tempRA[i];
    if (RA[SA[n-1]] == n-1) break; // nice optimization trick
    }
}

map<int,int> idx;

bool check(int mi, int k) {
    int N = n;
    vector<int> covered(N);
    int coveredTill = 0;
    F(i,0,N) {
        if (mi >= idx[i]) {
            int newCoveredTill = i + k;
            F(j,max(i,coveredTill),min(i+k,n))
                covered[j] = 1;
            coveredTill = newCoveredTill - 1;
        }
    }
    // D(accumulate(begin(covered)+n/2, begin(covered)+n-1, 0));
    int inRow = 0;
    F(i,1,N-1) {
        if (covered[i]) {
            if (++inRow == n/2) {
                return true;
            }
        } else {
            inRow = 0;
        }
    }
    return false;
}

int main () {
    string s;
    R(n,k,s);
    s = s + s + "$";
    strcpy(T, s.c_str());
    n = s.size();
    constructSA();
    
    F(i,0,n)
        idx[SA[i]] = i;
    
    int lo = 0, hi = n, mi;
    while (lo != hi) {
        mi = (lo + hi) / 2;
        if (check(mi, k))
            hi = mi;
        else
            lo = mi + 1;
    }
    int start = 0;
    F(i,0,n) {
        if (idx[i] == lo) {
            start = i;
        }
    }
    F(i,0,k)
        cout << s[(start + i)%(n-1)];
    cout << endl;

    return 0;
}
