#include <bits/stdc++.h>
using namespace std;
typedef long long int ll;

vector<ll> sa,pos,tmp,lcp;
ll N, gap;

bool cp(int i,int j){
    if (pos[i] != pos[j]) return pos[i] < pos[j];
    i += gap;
    j += gap;
    return (i < N && j < N) ? pos[i] < pos[j] : i > j;
}

struct SA{
    string s;
    SA(string sp):s(sp){
        N=s.length();
        sa=pos=tmp=lcp=vector<ll>(N);
        cerr<<"allocated"<<endl;
        buildSA();
        cerr<<"created SA"<<endl;
        buildLCP();
        cerr<<"created LCP"<<endl;
    }
    //sa[i] tells sufix beginning that is i-th when sorted
    void buildSA(){
        for(int i=0; i<N; ++i) {
            sa[i] = i;
            pos[i] = s[i];
        }
        //for(ll n:sa)cout<<n<<' ';cout<<endl;
        for (gap = 1;; gap *= 2){
            //cout<<"building "<<gap<<endl;
            sort(sa.begin(), sa.end(), cp);
            //cout<<"sorted "<<gap<<endl;
            for(int i=0; i<N-1; ++i) tmp[i + 1] = tmp[i] + cp(sa[i], sa[i+1]);
            for(int i=0; i<N  ; ++i) pos[sa[i]] = tmp[i];
            if (tmp[N-1] == N-1) break;
        }
    }
    void buildLCP(){
        int k=0;
        for(int i=0; i<N; ++i) if (pos[i] != N-1)	{
            int j = sa[pos[i]+1];
            while(s[i+k] == s[j+k]) ++k;
            lcp[pos[i]] = k;
            if (k)--k;
        }
    }
};

struct Range{
    ll f,t;
    bool operator<(const Range &r)const{
        return f!=r.f?f<r.f:t<r.t;
    }
    ll size(){return t-f;}
};

void remove(set<Range> &rs, Range r){
    auto it=rs.lower_bound(r);
    if(it!=rs.begin())--it;
    while(it!=rs.end()){
        if(r.t <= it->f) break; // does not cross
        if(it->t <= r.f) { //assert(false); // bad lowerbound
            ++it; 
            continue;
        }
        if(r.f <= it->f && it->t <= r.t){ // over the whole range
            it=rs.erase(it);
        }else if(it->f <= r.f && it->t <= r.t){ // slice the end
            Range n={it->f,r.f};
            rs.erase(it);
            if(n.size()) it=rs.insert(n).first;
        }else if(r.f <= it->f && r.t <= it->t){ // slice the beginning
            Range n={r.t,it->t};
            rs.erase(it);
            if(n.size()) it=rs.insert(n).first;
        }else if(it->f <= r.f && r.t <= it->t){ // split in two
            Range n={it->f,r.f};
            Range m={r.t,it->t};
            rs.erase(it);
            if(n.size()) it=rs.insert(n).first;
            if(m.size()) it=rs.insert(m).first;
        }
    }
}

int main(){
    ll N,K;cin>>N>>K;
    string s;cin>>s;
    s+=s;
    SA a(s);
    set<Range> rs;
    rs.insert({0,N});
    for(ll n:sa){
        if(n>=N)continue;
        remove(rs,{n,n+K});
        if(n+K>N)remove(rs,{n-N,n+K-N});
        if(rs.empty()){
            ll start=n;
            for(int i=0; i<K; ++i){
                cout<<s[(n+i)%N];
            }
            cout<<endl;
            break;
        }
    }

    return 0;
}

